<script setup lang="tsx">
import { Form, FormSchema } from '@/components/Form'
import { useForm } from '@/hooks/web/useForm'
import { PropType, reactive, watch } from 'vue'
import { useValidator } from '@/hooks/web/useValidator'

const { required } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<any>,
    default: () => null
  },
  actionType: {
    type: String,
    default: 'add'
  }
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const formSchema = reactive<FormSchema[]>([
  {
    field: 'id',
    label: '主键',
    component: 'Input',
    hidden: true
  },{
    field: 'repCode',
    label: '报告编码',
    component: 'Input',
    componentProps: {
      
    },
    formItemProps: {
      rules: [required()],
    },
  },
  {
    field: 'repName',
    label: '报名名称',
    component: 'Input',
    componentProps: {
      
    },
    formItemProps: {
      rules: [required()],
    },
  },
  {
    field: 'indexCode',
    label: '指标编码',
    component: 'Input',
    componentProps: {
      
    },
    formItemProps: {
      rules: [required()],
    },
  },
  {
    field: 'indexName',
    label: '指标名称',
    component: 'Input',
    componentProps: {
      
    },
    formItemProps: {
      rules: [required()],
    },
  },
  {
    field: 'indexRule',
    label: '指标规则',
    component: 'Input',
    colProps: {
      span: 24
    },
    componentProps: {
      type: 'textarea',
      rows:4
    }
  }
])

const rules = reactive({
  
})

const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :schema="formSchema" />
</template>

